#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	dx		pow(10,-3)	//the width of box
#define	Number	pow(10,5)	//the numebr of data
dsfmt_t dsfmt1;				//random numebr

void PDF_normal( double *data , int data_num ,double data_min , int imax , double *output){	//PDF
	int i ;
	
	for( i=0 ; i<data_num ; i++ ){
		output[(int)( ( data[i] - data_min )/dx) ] += 1.0/data_num;
	}
	for( i=0 ; i<imax ; i++){
		output[i] /= dx;
	}
}

int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i, j;
	double *rand , *F;
	rand = (double *)calloc( Number , sizeof(double) );
	double data_min , data_max;
	int imax;
	
	FILE *fpPDF , *fpCDF;
	if( ( fpPDF = fopen("PDF.dat","w") ) == NULL){
		printf("File Error : PDF");
		exit(1);
	}
	if( (fpCDF = fopen("CDF.dat","w") ) == NULL){
		printf("File Error : CDF");
		exit(1);
	}
	
	for( i= 0; i< Number ; i++){	//generate the random number
		rand[i] = dsfmt_genrand_close_open(&dsfmt1);
		data_min = ( i== 0 || data_min > rand[i] )? rand[i] : data_min;
		data_max = ( i== 0 || data_max < rand[i] )? rand[i] : data_max;
	}
	
	//PDF
	imax = (int)( ( data_max - data_min )/dx ) + 1;
	F = (double * )calloc( imax , sizeof(double) );
	PDF_normal( rand , Number , data_min , imax , F);
	
	for(i=0;i<imax;i++){
		fprintf( fpPDF , "%f %f\n", data_min+(i+0.5)*dx ,F[i]);
	}
	//
	//CDF
	qsort( rand , Number , sizeof(double) , double_comp);
	for(i = 0; i < Number ; i++){
		fprintf( fpCDF , "%f %f\n" , rand[i] , (double)(i+1)/Number );
	}
	
	fclose(fpPDF);
	fclose(fpCDF);
	free(rand);
	free(F);
	
	return 0;
}


